#include <iostream>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <climits>

using namespace std;

const double PI = 3.14159265358979323846;

int main()
{
	freopen ( "crimsonland.in", "rt", stdin );
	//freopen ( "crimsonland.out", "wt", stdout );

	int testn;
	cin >> testn;

	for ( int testi = 0; testi < testn; testi++ )
	{
		double angle[20200] = {0};

		int n, a, x0, y0;
		cin >> n >> a >> x0 >> y0;
		
		assert (n >= 1 && n <= 10000);
		assert (a >= 1 && a <= 180);
		assert (x0 >= -10000 && x0 <= 10000);
		assert (y0 >= -10000 && y0 <= 10000);

		for ( int i = 0; i < n; i++ )
		{
			int x, y;
			cin >> x >> y;
			assert (x >= -10000 && x <= 10000);
			assert (y >= -10000 && y <= 10000);
			assert (x != x0 || y != y0);

			x -= x0;
			y -= y0;
			double an = 180.0 * atan2((double)y, (double)x) / PI;
			angle[i] = an < 0 ? an + 360 : an ;
		}

		sort ( angle, angle + n );

		for ( int i = 0; i < n; i++ )
			angle[ i + n ] = angle[i] + 360;

		int minshoot = INT_MAX;
		for ( int start = 0; start < n; start++ )
		{
			int edge = start, shoot = 1;
			for ( int to = 1; to < n; to++ )
			{
				if ( angle[start + to] - angle[edge] > a )
				{
					shoot++;
					edge = to + start;
				}
			}
			if ( shoot < minshoot )
				minshoot = shoot;
		}
		cout << minshoot << endl;
	}

	return 0;
}