program crimsonland;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const eps: extended = 0.000000001;

function sign(a: extended) : extended;
begin
  if (a < 0) then
    sign := -1
  else if (a > 0) then
    sign :=  1
  else
    sign := 0;
end;

function atan2(x, y: extended) : extended;
begin
  if (x > 0) then
    atan2 := arctan(y/x)
  else if (x < 0) then
    atan2 := arctan(y/x) + PI
  else
    atan2 := PI/2*sign(y);
end;

var
  ti, tn: integer;
  n: integer;
  a: extended;
  x0, y0: integer;
  x, y: integer;
  angle: array[1..10000] of extended;
  i, j: integer;
  temp, curangle:extended;
  result: integer;
  curindex, edge, shoot: integer;

  begin
  assign(input, 'crimsonland.in');
  reset(input);
  //assign(output, 'crimsonland.out');
  //rewrite(output);

  read(tn);

  for ti := 1 to tn do
  begin
    read(n, a);
    assert((n >= 1) and (n <= 10000), 'Assert!!!');
    assert ((a >= 1) and (a <= 180), 'Assert!!!');

    a := a*PI/180;
    read(x0, y0);
		assert ((x0 >= -10000) and (x0 <= 10000), 'Assert!!!');
		assert ((y0 >= -10000) and (y0 <= 10000), 'Assert!!!');

    for i := 1 to n do
    begin
      read(x, y);
    	assert ((x >= -10000) and (x <= 10000), 'Assert!!!');
		  assert ((y >= -10000) and (y <= 10000), 'Assert!!!');
      assert ((x <> x0) or (y <> y0), 'Assert!!!');

      x := x - x0;
      y := y - y0;

      angle[i] := atan2(1.0*x, 1.0*y);

      if (angle[i] < 0) then
        angle[i] := angle[i] + 2*PI;
    end;

    for i := 1 to n - 1 do
      for j := i + 1 to n do
        if (angle[j] < angle[i]) then
        begin
          temp := angle[i];
          angle[i] := angle[j];
          angle[j] := temp;
        end;

    result := MaxInt;
		for i := 1 to n do
    begin
			edge := i;
      shoot := 1;

			for j := 1 to n - 1 do
			begin
        curindex := i + j;
        if (i + j > n) then
        begin
           curindex := i + j - n;
           curangle := angle[curindex] + 2*PI;
        end
        else
        begin
          curangle := angle[curindex];
        end;

				if ((curangle - angle[edge]) - a > eps) then
				begin
					shoot := shoot + 1;
					edge := curindex;
				end
			end;

			if (shoot < result) then
				result := shoot;
    end;
		writeln(result);

  end;

  close(input);
  //close(output);
end.
